local DefileCalendar = {
  frame = CreateFrame("Frame"),
  set = 0  
}

DefileCalendar_EventRowArray = {}   
DefileCalendar_EventHeaderArray = {}              

defileCaldendarFrame_Updatehooksw = false

DefileCalendar.frame:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" and DefileCalendar.set == 0 then
		DefileCalendar.set = 1
		if not defileCaldendarFrame_Updatehooksw then
			ToggleCalendar()
			ToggleCalendar()
			CalendarFrame:HookScript("OnShow", showDefileCalendar)
			CalendarFrame:HookScript("OnHide", hideDefileCalendar)
			defileCaldendarFrame_Updatehooksw = true
		end
	end

	if event == "CALENDAR_ACTION_PENDING" and CalendarIsActionPending() == false then
	end
end)
      
local function _GetDayOfWeek(index)
	return mod(index - 1, 7) + 1;
end

local function _GetWeekdayIndex(index)
	-- the expanded form for the left input to mod() is:
	-- (index - 1) + (CALENDAR_FIRST_WEEKDAY - 1)
	-- why the - 1 and then + 1 before return? because lua has 1-based indexes! awesome!
	return mod(index - 2 + CALENDAR_FIRST_WEEKDAY, 7);
end
	  
function loadDefileEvents()
	local i,EventDay,EventIndex
	for EventDay = 1, 31, 1 do
		local i = CalendarGetNumDayEvents(0, EventDay)
		if i > 0 then
			for EventIndex = 1, i, 1 do
				local EventName, EventHour, EventMinute, calendarType, sequenceType, eventType, EventTexture, _, EventInviteStatus = CalendarGetDayEvent(0, EventDay, EventIndex)
				if calendarType == "GUILD_EVENT" then
					local frame,alreadyExists = _CreateEventHeader(EventDay)
					if alreadyExists == false then
						_AddEventToFrame(frame)
					end

					frame,alreadyExists = _CreateEventItem(EventIndex, EventDay, EventName, EventHour, EventMinute, EventTexture, EventInviteStatus)
					if alreadyExists == false then
						_AddEventToFrame(frame)
					end					
				end	
			end
		end
	end
end

function _CreateEventHeader(EventDay)
	local frameChildren = { DefileCalendar_Main_ScrollFrame:GetChildren() }
	for _, frameChild in ipairs(frameChildren) do
		if frameChild:GetName() == "DefileCalendar_HeaderRow"..EventDay then
			return frameChild, true
		end
	end
	
	frame = CreateFrame("Frame", "DefileCalendar_HeaderRow"..EventDay, DefileCalendar_Main_ScrollFrame, "DefileCalendar_HeaderRow")
	frame.HeaderText:SetText(CALENDAR_WEEKDAY_NAMES[_GetDayOfWeek(_GetWeekdayIndex(EventDay))])
	return frame, false
end

function _CreateEventItem(EventIndex, EventDay, EventName, EventHour, EventMinute, EventTexture, EventInviteStatus)
	local frameChildren = { DefileCalendar_Main_ScrollFrame:GetChildren() }
	for _, frameChild in ipairs(frameChildren) do
		if frameChild:GetName() == "DefileCalendar_ListRow"..EventDay..","..EventIndex then
			return frameChild, true
		end
	end
	frame = CreateFrame("Frame", "DefileCalendar_ListRow"..EventDay..","..EventIndex, DefileCalendar_Main_ScrollFrame, "DefileCalendar_ListRow")
	frame.EventName:SetText(EventName)
	frame.EventTexture:SetTexture("Interface\\LFGFrame\\LFGIcon-"..EventTexture)
	if EventInviteStatus == 7 then
		frame.EventSignup:SetText("Cancel Signup")
	else
		frame.EventSignup:SetText("Sign Up")
	end
	frame.EventSignup:RegisterForClicks("AnyUp")
	frame.EventSignup:SetScript("OnClick", function (self, button, down) 
		if self:GetText() == "Sign Up" then
			signupForEvent(EventDay, EventIndex)
			self:SetText("Cancel Signup")
		else
			cancelSignupForEvent(EventDay, EventIndex)
			self:SetText("Sign Up")
		end
	end)

	frame.EventMembers:SetScript("OnEnter", function (...)
		queryDefileEventMembers(EventDay, EventIndex)
	end)
	return frame, false	
end

function _AddEventToFrame(Frame)
	local frameChildren = { DefileCalendar_Main_ScrollFrame:GetChildren() }
	local numChildren = 0
	for _, frameChild in ipairs(frameChildren) do
		if frameChild:IsShown() then
			numChildren = numChildren + 1
		end
	end
	Frame:SetPoint("TOPLEFT", DefileCalendar_Main, "TOPLEFT", 15, numChildren * -35)
end

function showDefileCalendar()
	loadDefileEvents()
	DefileCalendar_Main:ClearAllPoints()
	DefileCalendar_Main:SetPoint("TOPLEFT", "CalendarFrame", "TOPRIGHT", 0, -10)
	DefileCalendar_Main:SetPoint("BOTTOMLEFT", "CalendarFrame", "BOTTOMRIGHT", 0, -10)
	DefileCalendar_Main:Show()
end

function hideDefileCalendar()
	DefileCalendar_Main:Hide()
end

function signupForEvent(EventDay, EventIndex)
	CalendarContextEventSignUp(0, EventDay, EventIndex)
end

function cancelSignupForEvent(EventDay, EventIndex)
	CalendarContextInviteRemove(0, EventDay, EventIndex)
end

function queryDefileEventMembers(EventDay, EventIndex)
	CalendarOpenEvent(0, EventDay, EventIndex)
end

DefileCalendar.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
DefileCalendar.frame:RegisterEvent("CALENDAR_ACTION_PENDING");
